std::mask_array< _Tp > Class Template Reference

## Public Types

typedef _Tp | value_type

## Public Member Functions

| mask_array (const mask_array &)
template<class _Dom >
void | operator%= (const _Expr< _Dom, _Tp > &) const
void | operator%= (const valarray< _Tp > &) const
template<class _Dom >
void | operator&= (const _Expr< _Dom, _Tp > &) const
void | operator&= (const valarray< _Tp > &) const
template<class _Dom >
void | operator*= (const _Expr< _Dom, _Tp > &) const
void | operator*= (const valarray< _Tp > &) const
template<class _Dom >
void | operator+= (const _Expr< _Dom, _Tp > &) const
void | operator+= (const valarray< _Tp > &) const
template<class _Dom >
void | operator-= (const _Expr< _Dom, _Tp > &) const
void | operator-= (const valarray< _Tp > &) const
template<class _Dom >
void | operator/= (const _Expr< _Dom, _Tp > &) const
void | operator/= (const valarray< _Tp > &) const
template<class _Dom >
void | operator<<= (const _Expr< _Dom, _Tp > &) const
void | operator<<= (const valarray< _Tp > &) const
template<class _Dom >
void | operator= (const _Expr< _Dom, _Tp > &) const
template<class _Ex >
void | operator= (const _Expr< _Ex, _Tp > &__e) const
void | operator= (const _Tp &) const
mask_array & | operator= (const mask_array &)
void | operator= (const valarray< _Tp > &) const
template<class _Dom >
void | operator>>= (const _Expr< _Dom, _Tp > &) const
void | operator>>= (const valarray< _Tp > &) const
template<class _Dom >
void | operator^= (const _Expr< _Dom, _Tp > &) const
void | operator^= (const valarray< _Tp > &) const
template<class _Dom >
void | operator|= (const _Expr< _Dom, _Tp > &) const
void | operator|= (const valarray< _Tp > &) const

## Friends

class | valarray< _Tp >

## Detailed Description

### template<class _Tp>
class std::mask_array< _Tp >

Reference to selected subset of an array.

A mask_array is a reference to the actual elements of an array specified by a bitmask in the form of an array of bool. The way to get a mask_array is to call operator[](valarray<bool>) on a valarray. The returned mask_array then permits carrying operations out on the referenced subset of elements in the original valarray.

For example, if a mask_array is obtained using the array (false, true, false, true) as an argument, the mask array has two elements referring to array[1] and array[3] in the underlying array.

Parameters

  Tp | Element type.

Definition at line 62 of file mask_array.h.

## Member Function Documentation

## operator%=()

template<class _Tp >

void std::mask_array< _Tp >::operator%= | ( | const valarray< _Tp > & |  | ) | const

Modulo slice elements by corresponding elements of v.

## operator&=()

template<class _Tp >

void std::mask_array< _Tp >::operator&= | ( | const valarray< _Tp > & |  | ) | const

Logical and slice elements with corresponding elements of v.

## operator*=()

template<class _Tp >

void std::mask_array< _Tp >::operator*= | ( | const valarray< _Tp > & |  | ) | const

Multiply slice elements by corresponding elements of v.

## operator+=()

template<class _Tp >

void std::mask_array< _Tp >::operator+= | ( | const valarray< _Tp > & |  | ) | const

Add corresponding elements of v to slice elements.

## operator-=()

template<class _Tp >

void std::mask_array< _Tp >::operator-= | ( | const valarray< _Tp > & |  | ) | const

Subtract corresponding elements of v from slice elements.

## operator/=()

template<class _Tp >

void std::mask_array< _Tp >::operator/= | ( | const valarray< _Tp > & |  | ) | const

Divide slice elements by corresponding elements of v.

## operator<<=()

template<class _Tp >

void std::mask_array< _Tp >::operator<<= | ( | const valarray< _Tp > & |  | ) | const

Left shift slice elements by corresponding elements of v.

## operator>>=()

template<class _Tp >

void std::mask_array< _Tp >::operator>>= | ( | const valarray< _Tp > & |  | ) | const

Right shift slice elements by corresponding elements of v.

## operator^=()

template<class _Tp >

void std::mask_array< _Tp >::operator^= | ( | const valarray< _Tp > & |  | ) | const

Logical xor slice elements with corresponding elements of v.

## operator|=()

template<class _Tp >

void std::mask_array< _Tp >::operator|= | ( | const valarray< _Tp > & |  | ) | const

Logical or slice elements with corresponding elements of v.

The documentation for this class was generated from the following files:

- valarray
- mask_array.h